<template>
    <CRow>
        <CCol class="tableContainer">
            <CCard class="tableCard">
                <CCardBody>
                    <UsersTable
                        :table-data="users"
                        @addUser="addUser"
                        @deleteUser="deleteUser"
                        @blockUser="blockUser"
                        @editUser="editUser"
                    />
                    <AdditionalUser
                        :is-open="additionUserModal.isOpen"
                        :errors="additionUserModal.errors"
                        @onClose="modalAction"
                    />
                    <DeletionUser
                        :is-open="deleteUserModal.isOpen"
                        :user-info="deleteUserModal.userInfo"
                        @onClose="modalAction"
                    />
                    <BlockingUser
                        :is-open="blockUserModal.isOpen"
                        :user-info="blockUserModal.userInfo"
                        @onClose="modalAction"
                    />
                    <EditingUser
                        :is-open="editingUserModal.isOpen"
                        :user-info="editingUserModal.userInfo"
                        :errors="editingUserModal.errors"
                        @onClose="modalAction"
                    />
                </CCardBody>
            </CCard>
        </CCol>
    </CRow>
</template>

<script>
import {mapGetters, mapActions} from 'vuex';

export default {
    name: "Users",
    data() {
        return {
            additionUserModal: {
                isOpen: false,
                errors: {},
            },
            deleteUserModal: {
                isOpen: false,
                userInfo: {},
            },
            blockUserModal: {
                isOpen: false,
                userInfo: {},
            },
            editingUserModal: {
                isOpen: false,
                userInfo: {},
                errors: {},
            },
        }
    },
    computed: {
        ...mapGetters(["users"]),
    },
    mounted() {
        this.changePreloaderState(true, 'Загрузка списка пользователей');
        this.$store.dispatch('getUsers')
            .catch(response => {
                let message = '';
                if ('message' in response) message = response.message;
                this.addToast({
                    toastInfo: message,
                    isVisibleToast: true,
                });
            })
            .finally(() => this.changePreloaderState(false, ''))
    },
    methods: {
        modalAction({closeType, data, modalType}) {
        // Закрывает модальнок окно.
        // closeType Boolean - сохранить перед закрытием
        // data Object - информация для отправки запроса
        // modalType String - тип модального окна
            if (closeType) {
                let requestType;
                let modalWindowType;
                let closeAfterConfirm = true;
                let titleForPreloader = '';
                switch (modalType) {
                    case 'addUser':
                        titleForPreloader = 'Добавление пользователя';
                        requestType = 'addUser';
                        modalWindowType = 'additionUserModal';
                        break;
                    case 'deleteUser':
                        titleForPreloader = 'Удаление пользователя';
                        requestType = 'deleteUser';
                        break;
                    case 'blockUser':
                        titleForPreloader = 'Блокировка пользователя';
                        requestType = 'blockUser';
                        break;
                    case 'editUser':
                        titleForPreloader = 'Сохранение данных пользователя';
                        requestType = 'editUser';
                        modalWindowType = 'editingUserModal';
                        break;
                    default:
                        titleForPreloader = '';
                        requestType = '';
                }
                this.changePreloaderState(true, titleForPreloader)
                this.$store.dispatch(requestType, data)
                    .then(response => {
                        this.addToast({
                            toastInfo: response,
                            isVisibleToast: true,
                            type: 'success',
                        })
                        if (closeAfterConfirm) {
                            this.closeModal(modalType);
                        }
                    })
                    .catch(response => {
                        let errors = {};
                        let message = '';
                        if ('errors' in response) errors = {...response.errors};
                        if ('message' in response) message = response.message;
                        this.addToast({
                            toastInfo: message,
                            isVisibleToast: true,
                        });
                        if ('errors' in this[modalWindowType]) {
                            this[modalWindowType].errors = {...errors};
                        }
                    })
                    .finally(() => this.changePreloaderState(false, ''))
            } else {
                this.closeModal(modalType);
            }
        },
        addUser() {
                // Открывает модальное окно

            this.additionUserModal.isOpen = true;
        },
        deleteUser(payload) {
        // Открывает модальное окно
        // Записывает информацию для передачи в модальное окно
            this.deleteUserModal.isOpen = true;
            this.deleteUserModal.userInfo = payload;
        },
        blockUser(payload) {
        // Открывает модальное окно
        // Записывает информацию для передачи в модальное окно
            this.blockUserModal.isOpen = true;
            this.blockUserModal.userInfo = payload;
        },
        editUser(payload) {
        // Открывает модальное окно
        // Записывает информацию для передачи в модальное окно
            this.editingUserModal.isOpen = true;
            this.editingUserModal.userInfo = payload;
        },
        closeModal(modalType) {
        // Закрывает модальное окно

            switch (modalType) {
                case 'addUser' :
                    this.additionUserModal.isOpen = false;
                    this.additionUserModal.errors = {};
                    break;
                case 'deleteUser' :
                    this.deleteUserModal.isOpen = false;
                    this.deleteUserModal.userInfo = {};
                    break;
                case 'blockUser' :
                    this.blockUserModal.isOpen = false;
                    this.blockUserModal.userInfo = {};
                    break;
                case 'editUser' :
                    this.editingUserModal.isOpen = false;
                    this.editingUserModal.userInfo = {};
                    this.editingUserModal.errors = {};
                    break;
            }
        },
        ...mapActions({addToast: 'toast/addToast'}),
    }
}
</script>
